﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace BallTrouble
{
    class BallTrouble
    {
        private List<Ball> balls = new List<Ball>();
        private volatile bool shutdown = false;
        private const int SLEEP_MS = 10;

        public BallTrouble(int readers, int writers, int time)
        {
            List<Thread> threads = new List<Thread>();
            for (int i = 0; i < readers; i++)
                threads.Add(new Thread(new ThreadStart(workerReader)));
            for (int i = 0; i < writers; i++)
                threads.Add(new Thread(new ThreadStart(workerWriter)));
            foreach (Thread t in threads)
                t.Start();

            System.Console.WriteLine("Total threads = {0}", threads.Count);

            Thread.Sleep(time * 1000);
            shutdown = true;
            foreach (Thread t in threads)
                t.Join();

            System.Console.WriteLine("Total balls = {0}", balls.Count);
        }

        public void workerReader()
        {
            while (!shutdown)
            {
                //lock (balls)
                {
                    foreach (Ball b in balls)
                    {
                        double x = b.getX();
                        double y = b.getY();
                    }
                }
                Thread.Sleep(SLEEP_MS);
            }
        }

        public void workerWriter()
        {
            while (!shutdown)
            {
                //lock (balls)
                {
                    balls.Add(new Ball(0.0, 0.0, 1.0));
                }
                Thread.Sleep(SLEEP_MS);
            }
        }

        static void Main(string[] args)
        {
            BallTrouble trouble = new BallTrouble(int.Parse(args[0]), int.Parse(args[1]), int.Parse(args[2]));
        }
    }
}
